Heap / BST

218. The Skyline Problem

A city's skyline is the outer contour of the silhouette formed by all the buildings in that city when viewed from a distance. Now suppose you are given the locations and height of all the buildings as shown on a cityscape photo (Figure A), write a program to output the skyline formed by these buildings collectively (Figure B). Buildings Skyline Contour The geometric information of each building is represented by a triplet of integers [Li, Ri, Hi], where Li and Ri are the x coordinates of the left and right edge of the ith building, respectively, and Hi is its height. It is guaranteed that 0 ≤ Li, Ri ≤ INT_MAX, 0 < Hi ≤ INT_MAX, and Ri - Li > 0. You may assume all buildings are perfect rectangles grounded on an absolutely flat surface at height 0.

For instance, the dimensions of all buildings in Figure A are recorded as: [ [2 9 10], [3 7 15], [5 12 12], [15 20 10], [19 24 8] ] .

The output is a list of "key points" (red dots in Figure B) in the format of [ [x1,y1], [x2, y2], [x3, y3], ... ] that uniquely defines a skyline. A key point is the left endpoint of a horizontal line segment. Note that the last key point, where the rightmost building ends, is merely used to mark the termination of the skyline, and always has zero height. Also, the ground in between any two adjacent buildings should be considered part of the skyline contour.

For instance, the skyline in Figure B should be represented as:[ [2 10], [3 15], [7 12], [12 0], [15 10], [20 8], [24, 0] ].

Notes:

The number of buildings in any input list is guaranteed to be in the range [0, 10000]. The input list is already sorted in ascending order by the left x position Li. The output list must be sorted by the x position. There must be no consecutive horizontal lines of equal height in the output skyline. For instance, [...[2 3], [4 5], [7 5], [11 5], [12 7]...] is not acceptable; the three lines of height 5 should be merged into one in the final output as such: [...[2 3], [4 5], [12 7], ...]

class Solution {
public:
    vector<pair<int, int>> getSkyline(vector<vector<int>>& buildings) {
        vector<pair<int, int>> res;
        vector<pair<int, int>> heights;
        for (auto building : buildings) {
            heights.push_back({building[0], -building[2]});
            heights.push_back({building[1], building[2]});
        }

        sort(heights.begin(), heights.end());

        multiset<int> heap;
        heap.insert(0);
        int pre = 0;
        int cur = 0;

        for (auto pos : heights) {
            if (pos.second < 0) {
                heap.insert(-pos.second);
            } else {
                heap.erase(heap.find(pos.second));
            }
            if (heap.empty()) cur = pos.second;
            else cur = *heap.rbegin();
            if (cur != pre) {
                res.push_back({pos.first, cur});
                pre = cur;
            }

        }
        return res;
    }
};

239. Sliding Window Maximum

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position.

For example, Given nums = [1,3,-1,-3,5,3,6,7], and k = 3.

Window position                Max
---------------               -----
[1  3  -1] -3  5  3  6  7       3
 1 [3  -1  -3] 5  3  6  7       3
 1  3 [-1  -3  5] 3  6  7       5
 1  3  -1 [-3  5  3] 6  7       5
 1  3  -1  -3 [5  3  6] 7       6
 1  3  -1  -3  5 [3  6  7]      7

Therefore, return the max sliding window as [3,3,5,5,6,7].

Note: You may assume k is always valid, ie: 1 ≤ k ≤ input array's size for non-empty array.

Follow up: Could you solve it in linear time?

Heap O(NlogK);

class Solution {
public:
    vector<int> maxSlidingWindow(vector<int>& nums, int k) {
        vector<int> res;
        if (!nums.size()) return res;
        priority_queue<pair<int, int>> pq;
        for (size_t i = 0; i < k; ++i) {
            pq.push({nums[i], i});
        }
        res.push_back(pq.top().first);
        for (size_t i = k; i < nums.size(); ++i) {
            pq.push({nums[i], i});
            while (!pq.empty() && i - pq.top().second >= k) pq.pop();
            res.push_back(pq.top().first);
        }

        return res;
    }
};

deque O(N)

class Solution {
public:
    vector<int> maxSlidingWindow(vector<int>& nums, int k) {
        vector<int> res;
        if (!nums.size()) return res;

        deque<size_t> q;
        for (size_t i = 0; i < k; ++i) {
            while (q.size() && nums[i] >= nums[q.back()]) q.pop_back();
            q.push_back(i);
        }
        res.push_back(nums[q.front()]);

        for (size_t i = k; i < nums.size(); ++i) {
            while (q.size() && i - k >= q.front()) q.pop_front();
            while (q.size() && nums[i] >= nums[q.back()]) q.pop_back();
            q.push_back(i);
            res.push_back(nums[q.front()]);
        }
        return res;
    }
};

295. Find Median from Data Stream

class MedianFinder {
public:

    // Adds a number into the data structure.
    void addNum(int num) {
        if (first_half.empty() || num <= first_half.top()) {
            first_half.push(num);
        } else {
            second_half.push(num);
        }

        if (second_half.size() > first_half.size()) {
            first_half.push(second_half.top());
            second_half.pop();
        } else if (first_half.size() > second_half.size() + 1) {
            second_half.push(first_half.top());
            first_half.pop();
        }
    }

    // Returns the median of current data stream
    double findMedian() {
        if (first_half.size() > second_half.size()) return first_half.top();
        return (first_half.top() + second_half.top())/ 2.0;
    }

private:
    priority_queue<int> first_half;
    priority_queue<int, vector<int>, greater<int>> second_half;
};

// Your MedianFinder object will be instantiated and called as such:
// MedianFinder mf;
// mf.addNum(1);
// mf.findMedian();

results matching ""

    No results matching ""